(***********************************************************************)
(*                                                                     *)
(*            cast objet en O'Caml                                     *)
(*                                                                     *)
(*            Emmanuel Chailloux, Equipe PPS, universite P7            *)
(*                                                                     *)
(*                                                                     *)
(***********************************************************************)

(* $Id: cast.ml,v 1.2 2001/08/30 15:30:34 emmanuel Exp $ *)

type id = unit -> unit;;

exception Cast_failure of string * int * int;;
exception Forbidden_downcast  of string * int * int;;
exception Forbidden_upcast of string * int * int;;

let create_id f = ((Obj.magic f):id);;

let string_of_id ( i : id) =  string_of_int (Obj.magic i);;

let check loc o1 ( k1 : id)  (k2 : id) = 
  if o1#___get_castable then 
    if  o1#___check_id k1 && o1#___check_id k2  then ()
    else 
      let a,b = loc in raise (Cast_failure ("at location", a, b))
  else       
    if o1#___check_exact_id k2 then () 
    else
      let a,b = loc in  raise (Forbidden_downcast ("at location", a, b))
;;

let check_from loc o1 (k_d : id) (k_c : id) = 
  if o1#___check_from k_d k_c then ()
  else 
   let a,b = loc in  raise (Forbidden_downcast ("at location", a, b))
;;

let check_sonof loc o1 ( k_d : id) (k_c : id)  = 
  if o1#___check_sonof k_d k_c then ()
  else 
    let a,b = loc in raise (Forbidden_upcast ("at location", a, b))
;;

let instanceof (loc : int * int)  o1 (k : id) =
   ((o1#___check_id k) : bool);;






