(***********************************************************************)
(*                                                                     *)
(*            cast objet en O'Caml                                     *)
(*                                                                     *)
(*            Emmanuel Chailloux, Equipe PPS, universite P7            *)
(*                                                                     *)
(*                                                                     *)
(***********************************************************************)

(* $Id$ *)

(* test6.ml : fichier de test 
 
   avec foncteurs 
*)

module A = 
struct 
  class a = object val x = 1 method get_x = x end
end;;

module type TOP = 
sig 
  class virtual top : 
  object ('a)
    method virtual to_string : string
    method print : unit
    method clone : 'a
    method eq : top -> bool
  end
end;;

module Fils (T : TOP) = 
struct
  class fils (x : int) =
  object (self  )
    inherit T.top
    val f = x
    method get_f = f
    method to_string = string_of_int f
    method eq ( x : T.top) =
      let xf = downcast x from T.top to fils in
        f = (xf#get_f)
 end
end;;

module Top = struct 
class virtual top = 
  object(self) 
    method virtual to_string :  string
    method print = print_string (self#to_string)
    method clone = Oo.copy(self)
    method eq (a : top) = true
 end
end;;

module Fils1 = Fils(Top);;

open Top;;

class left (x : int) = 
  object (self  ) 
  inherit top 
  val l = x
  method get_l = l
  method to_string = string_of_int l
  method eq ( x : top) = 
    let xl = downcast x from top to left in 
        l = (xl#get_l)
end;;

class right (x : int) = 
  object (self  ) 
  inherit top 
  val l = x
  method get_l = l
  method to_string = string_of_int l
  method eq (x:top) = 
    let xl = downcast x from top to right in 
        l = (xl#get_l)
end;;

let l = new left 10;;
let l2 = new left 10;;
let t1 = upcast l from left to  top;;
let r =  new right 10;;
let t2 = upcast r from right to  top;;

l#print;; print_newline();;
l2#print;; print_newline();;

if l#eq(l2 :> top) then print_string "OK"
else print_string "PB";;

print_newline();;

try 
  ignore(l#eq (upcast r from right to  top));
  print_string "PB"
with Cast.Cast_failure _ -> print_string "OK";;

print_newline();; 

